From bbde8bdbf490171dfa4ccf9b9aab0388664b7ad4 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Wed, 15 May 2024 03:29:23 +0300
Subject: [PATCH 62/62] sdl3: Make theme capstrings sdl3-client specific ones

See RM #617

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 client/gui-sdl3/themespec.c                           | 8 ++++----
 data/themes/gui-sdl3/human/city.tspec                 | 2 +-
 data/themes/gui-sdl3/human/city_fist.tspec            | 2 +-
 data/themes/gui-sdl3/human/dip_icons.tspec            | 2 +-
 data/themes/gui-sdl3/human/icons.tspec                | 2 +-
 data/themes/gui-sdl3/human/small_theme_buttons.tspec  | 2 +-
 data/themes/gui-sdl3/human/tech_tree.tspec            | 2 +-
 data/themes/gui-sdl3/human/theme.themespec            | 2 +-
 data/themes/gui-sdl3/human/theme_boxs.tspec           | 2 +-
 data/themes/gui-sdl3/human/theme_buttons.tspec        | 2 +-
 data/themes/gui-sdl3/human/theme_orders_buttons.tspec | 2 +-
 data/themes/gui-sdl3/human/theme_scrolls.tspec        | 2 +-
 12 files changed, 15 insertions(+), 15 deletions(-)

diff --git a/client/gui-sdl3/themespec.c b/client/gui-sdl3/themespec.c
index fa3edf8663..0de9274adc 100644
--- a/client/gui-sdl3/themespec.c
+++ b/client/gui-sdl3/themespec.c
@@ -47,11 +47,11 @@
 
 #include "themespec.h"
 
-#define THEMESPEC_SDL3_CAPSTR "+Freeciv-sdl2-3.2-themespec-Devel-2022-Jul-06 duplicates_ok"
+#define THEMESPEC_SDL3_CAPSTR "+Freeciv-sdl3-3.2-themespec-Devel-2022-Jul-06 duplicates_ok"
 /*
  * Themespec capabilities acceptable to this program:
  *
- * +Freeciv-3.2-sdl2-themespec  -  basic format for Freeciv versions 3.2.x;
+ * +Freeciv-3.2-sdl3-themespec  -  basic format for Freeciv versions 3.2.x;
  *                                 required
  *
  * duplicates_ok  -  we can handle existence of duplicate tags
@@ -59,11 +59,11 @@
  *                   have duplicates should specify "+duplicates_ok")
  */
 
-#define SPEC_SDL3_CAPSTR "+Freeciv-sdl2-spec-Devel-2022-Dec-05"
+#define SPEC_SDL3_CAPSTR "+Freeciv-sdl3-spec-Devel-2022-Dec-05"
 /*
  * Individual spec file capabilities acceptable to this program:
  *
- * +Freeciv-3.2-sdl2-spec  -  basic format for Freeciv versions 3.2.x; required
+ * +Freeciv-3.2-sdl3-spec  -  basic format for Freeciv versions 3.2.x; required
  */
 
 #define THEMESPEC_SUFFIX ".themespec"
diff --git a/data/themes/gui-sdl3/human/city.tspec b/data/themes/gui-sdl3/human/city.tspec
index b0c452db6f..bfec5c5cf9 100644
--- a/data/themes/gui-sdl3/human/city.tspec
+++ b/data/themes/gui-sdl3/human/city.tspec
@@ -2,7 +2,7 @@
 [spec]
 
 ; Format and options of this spec file:
-options = "+Freeciv-sdl2-spec-Devel-2022-Dec-05"
+options = "+Freeciv-sdl3-spec-Devel-2022-Dec-05"
 
 [info]
 
diff --git a/data/themes/gui-sdl3/human/city_fist.tspec b/data/themes/gui-sdl3/human/city_fist.tspec
index 1af0732714..930340366a 100644
--- a/data/themes/gui-sdl3/human/city_fist.tspec
+++ b/data/themes/gui-sdl3/human/city_fist.tspec
@@ -1,7 +1,7 @@
 [spec]
 
 ; Format and options of this spec file:
-options = "+Freeciv-sdl2-spec-Devel-2022-Dec-05"
+options = "+Freeciv-sdl3-spec-Devel-2022-Dec-05"
 
 [info]
 
diff --git a/data/themes/gui-sdl3/human/dip_icons.tspec b/data/themes/gui-sdl3/human/dip_icons.tspec
index 6bdef3d308..f3a0fd5ff7 100644
--- a/data/themes/gui-sdl3/human/dip_icons.tspec
+++ b/data/themes/gui-sdl3/human/dip_icons.tspec
@@ -1,7 +1,7 @@
 [spec]
 
 ; Format and options of this spec file:
-options = "+Freeciv-sdl2-spec-Devel-2022-Dec-05"
+options = "+Freeciv-sdl3-spec-Devel-2022-Dec-05"
 
 [info]
 
diff --git a/data/themes/gui-sdl3/human/icons.tspec b/data/themes/gui-sdl3/human/icons.tspec
index f9a6a6c5f4..fd7fdd7ba7 100644
--- a/data/themes/gui-sdl3/human/icons.tspec
+++ b/data/themes/gui-sdl3/human/icons.tspec
@@ -1,7 +1,7 @@
 [spec]
 
 ; Format and options of this spec file:
-options = "+Freeciv-sdl2-spec-Devel-2022-Dec-05"
+options = "+Freeciv-sdl3-spec-Devel-2022-Dec-05"
 
 [info]
 
diff --git a/data/themes/gui-sdl3/human/small_theme_buttons.tspec b/data/themes/gui-sdl3/human/small_theme_buttons.tspec
index 56522b30ff..4532408939 100644
--- a/data/themes/gui-sdl3/human/small_theme_buttons.tspec
+++ b/data/themes/gui-sdl3/human/small_theme_buttons.tspec
@@ -2,7 +2,7 @@
 [spec]
 
 ; Format and options of this spec file:
-options = "+Freeciv-sdl2-spec-Devel-2022-Dec-05"
+options = "+Freeciv-sdl3-spec-Devel-2022-Dec-05"
 
 [info]
 
diff --git a/data/themes/gui-sdl3/human/tech_tree.tspec b/data/themes/gui-sdl3/human/tech_tree.tspec
index a3530b250b..be1e0188d8 100644
--- a/data/themes/gui-sdl3/human/tech_tree.tspec
+++ b/data/themes/gui-sdl3/human/tech_tree.tspec
@@ -1,7 +1,7 @@
 [spec]
 
 ; Format and options of this spec file:
-options = "+Freeciv-sdl2-spec-Devel-2022-Dec-05"
+options = "+Freeciv-sdl3-spec-Devel-2022-Dec-05"
 
 [info]
 
diff --git a/data/themes/gui-sdl3/human/theme.themespec b/data/themes/gui-sdl3/human/theme.themespec
index 6106d0324f..72ea31267b 100644
--- a/data/themes/gui-sdl3/human/theme.themespec
+++ b/data/themes/gui-sdl3/human/theme.themespec
@@ -1,7 +1,7 @@
 [themespec]
 
 ; Format and options of this themespec file:
-options = "+Freeciv-sdl2-3.2-themespec-Devel-2022-Jul-06"
+options = "+Freeciv-sdl3-3.2-themespec-Devel-2022-Jul-06"
 
 ; A simple name for the themespec specified by this file:
 name = "human"
diff --git a/data/themes/gui-sdl3/human/theme_boxs.tspec b/data/themes/gui-sdl3/human/theme_boxs.tspec
index df703b1456..a60fb4b267 100644
--- a/data/themes/gui-sdl3/human/theme_boxs.tspec
+++ b/data/themes/gui-sdl3/human/theme_boxs.tspec
@@ -2,7 +2,7 @@
 [spec]
 
 ; Format and options of this spec file:
-options = "+Freeciv-sdl2-spec-Devel-2022-Dec-05"
+options = "+Freeciv-sdl3-spec-Devel-2022-Dec-05"
 
 [info]
 
diff --git a/data/themes/gui-sdl3/human/theme_buttons.tspec b/data/themes/gui-sdl3/human/theme_buttons.tspec
index 88d80f8f66..90e140a3ca 100644
--- a/data/themes/gui-sdl3/human/theme_buttons.tspec
+++ b/data/themes/gui-sdl3/human/theme_buttons.tspec
@@ -2,7 +2,7 @@
 [spec]
 
 ; Format and options of this spec file:
-options = "+Freeciv-sdl2-spec-Devel-2022-Dec-05"
+options = "+Freeciv-sdl3-spec-Devel-2022-Dec-05"
 
 [info]
 
diff --git a/data/themes/gui-sdl3/human/theme_orders_buttons.tspec b/data/themes/gui-sdl3/human/theme_orders_buttons.tspec
index 605194db89..de1477b78e 100644
--- a/data/themes/gui-sdl3/human/theme_orders_buttons.tspec
+++ b/data/themes/gui-sdl3/human/theme_orders_buttons.tspec
@@ -2,7 +2,7 @@
 [spec]
 
 ; Format and options of this spec file:
-options = "+Freeciv-sdl2-spec-Devel-2022-Dec-05"
+options = "+Freeciv-sdl3-spec-Devel-2022-Dec-05"
 
 [info]
 
diff --git a/data/themes/gui-sdl3/human/theme_scrolls.tspec b/data/themes/gui-sdl3/human/theme_scrolls.tspec
index d8a721ba15..5be67c25c5 100644
--- a/data/themes/gui-sdl3/human/theme_scrolls.tspec
+++ b/data/themes/gui-sdl3/human/theme_scrolls.tspec
@@ -2,7 +2,7 @@
 [spec]
 
 ; Format and options of this spec file:
-options = "+Freeciv-sdl2-spec-Devel-2022-Dec-05"
+options = "+Freeciv-sdl3-spec-Devel-2022-Dec-05"
 
 [info]
 
-- 
2.43.0