From 54ee2e5b9e35268aa8a981f61f1b1b704fc5c84e Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Thu, 16 May 2024 03:35:08 +0300
Subject: [PATCH 81/81] Correct "contructor" to "constructor"

See RM #626

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 client/gui-qt/dialogs.cpp   | 4 ++--
 client/gui-qt/fc_client.cpp | 4 ++--
 client/gui-qt/hudwidget.cpp | 6 +++---
 client/gui-qt/mapview.cpp   | 2 +-
 client/gui-qt/shortcuts.cpp | 6 +++---
 5 files changed, 11 insertions(+), 11 deletions(-)

diff --git a/client/gui-qt/dialogs.cpp b/client/gui-qt/dialogs.cpp
index 41cff1b92d..438c88f1ae 100644
--- a/client/gui-qt/dialogs.cpp
+++ b/client/gui-qt/dialogs.cpp
@@ -3904,7 +3904,7 @@ void popup_pillage_dialog(struct unit *punit, bv_extras extras)
 }
 
 /***********************************************************************//**
-  Disband Message box contructor
+  Disband Message box constructor
 ***************************************************************************/
 disband_box::disband_box(struct unit_list *punits,
                          QWidget *parent) : hud_message_box(parent)
@@ -4417,7 +4417,7 @@ void popup_upgrade_dialog(struct unit_list *punits)
 }
 
 /***********************************************************************//**
-  Contructor for units_select
+  Constructor for units_select
 ***************************************************************************/
 units_select::units_select(tile *ptile, QWidget *parent)
 {
diff --git a/client/gui-qt/fc_client.cpp b/client/gui-qt/fc_client.cpp
index 8429a7281a..6b1d349d54 100644
--- a/client/gui-qt/fc_client.cpp
+++ b/client/gui-qt/fc_client.cpp
@@ -910,7 +910,7 @@ void fc_client::create_cursors(void)
 }
 
 /************************************************************************//**
-  Contructor for corner widget (used for menubar)
+  Constructor for corner widget (used for menubar)
 ****************************************************************************/
 fc_corner::fc_corner(QMainWindow *qmw): QWidget()
 {
@@ -1158,7 +1158,7 @@ void fc_game_tab_widget::current_changed(int index)
 }
 
 /************************************************************************//**
-  Pregame options contructor
+  Pregame options constructor
 ****************************************************************************/
 pregame_options::pregame_options(QWidget *parent) : QWidget(parent)
 {
diff --git a/client/gui-qt/hudwidget.cpp b/client/gui-qt/hudwidget.cpp
index 02fca2ca62..323bac8dc7 100644
--- a/client/gui-qt/hudwidget.cpp
+++ b/client/gui-qt/hudwidget.cpp
@@ -927,7 +927,7 @@ void hud_action::on_clicked()
 }
 
 /************************************************************************//**
-  Units action contructor, holds possible hud_actions
+  Units action constructor, holds possible hud_actions
 ****************************************************************************/
 unit_actions::unit_actions(QWidget *parent, unit *punit) : QWidget(parent)
 {
@@ -1707,7 +1707,7 @@ void show_new_turn_info()
 }
 
 /************************************************************************//**
-  Hud unit combat contructor, prepares images to show as result
+  Hud unit combat constructor, prepares images to show as result
 ****************************************************************************/
 hud_unit_combat::hud_unit_combat(int attacker_unit_id, int defender_unit_id,
                                  int attacker_hp, int defender_hp,
@@ -1986,7 +1986,7 @@ void scale_widget::mousePressEvent(QMouseEvent *event)
 }
 
 /************************************************************************//**
-  Hud battle log contructor
+  Hud battle log constructor
 ****************************************************************************/
 hud_battle_log::hud_battle_log(QWidget *parent) : QWidget(parent)
 {
diff --git a/client/gui-qt/mapview.cpp b/client/gui-qt/mapview.cpp
index 496cec889e..d2a62248ff 100644
--- a/client/gui-qt/mapview.cpp
+++ b/client/gui-qt/mapview.cpp
@@ -743,7 +743,7 @@ void minimap_view::update_pixmap(const QImage &image)
 }
 
 /**********************************************************************//**
-  Minimap thread's contructor
+  Minimap thread's constructor
 **************************************************************************/
 minimap_thread::minimap_thread(QObject *parent) : QThread(parent)
 {
diff --git a/client/gui-qt/shortcuts.cpp b/client/gui-qt/shortcuts.cpp
index 453ea43c42..2fdafe6c96 100644
--- a/client/gui-qt/shortcuts.cpp
+++ b/client/gui-qt/shortcuts.cpp
@@ -203,7 +203,7 @@ QString shortcut_to_string(fc_shortcut *sc)
 }
 
 /**********************************************************************//**
-  fc_shortcuts contructor
+  fc_shortcuts constructor
 **************************************************************************/
 fc_shortcuts::fc_shortcuts()
 {
@@ -340,7 +340,7 @@ fc_shortcut_popup::fc_shortcut_popup(QWidget *parent): QDialog()
 }
 
 /**********************************************************************//**
-  Custom line edit contructor
+  Custom line edit constructor
 **************************************************************************/
 line_edit::line_edit(): QLineEdit()
 {
@@ -574,7 +574,7 @@ void fc_sc_button::popup_error()
 }
 
 /**********************************************************************//**
-  Contructor for shortcut dialog
+  Constructor for shortcut dialog
 **************************************************************************/
 fc_shortcuts_dialog::fc_shortcuts_dialog(QWidget *parent)
   : QDialog(parent)
-- 
2.43.0