From b992700c949b0639d155aba18290706214f00bdd Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Wed, 22 May 2024 00:46:32 +0300
Subject: [PATCH 91/91] stdsounds: Add w_generic sound effect

Sound is Public Domain (CC0) sample by Trex0n
https://opengameart.org/content/happy-and-sad-tuba-fanfare

See RM #658

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/stdsounds.soundspec        |   5 +++--
 data/stdsounds/Makefile.am      |   1 +
 data/stdsounds/fanfarehappy.ogg | Bin 0 -> 37060 bytes
 meson.build                     |   1 +
 4 files changed, 5 insertions(+), 2 deletions(-)
 create mode 100644 data/stdsounds/fanfarehappy.ogg

diff --git a/data/stdsounds.soundspec b/data/stdsounds.soundspec
index f1cf087ad3..28f6081702 100644
--- a/data/stdsounds.soundspec
+++ b/data/stdsounds.soundspec
@@ -9,7 +9,8 @@ artists = "\
  OpenQuartz - Frank Condello (pox@planetquake.com) [pox]\
  Warzone - Eidos Entertainment (GPL release) [warzone]\
  Eskapada - eskapada@o2.pl (Public Domain) [jt]\
- Spring Spring - https://opengameart.org/users/spring-spring [spring]"
+ Spring Spring - https://opengameart.org/users/spring-spring [spring]\
+ Trex0n - https://opengameart.org/users/trex0n [trex0n]"
 
 ; For a list of tags used see README.sound, buildings.ruleset and
 ; units.ruleset.
@@ -165,7 +166,7 @@ m_transport = "stdsounds/inh2o.ogg" ; [pox]
 m_trireme = "stdsounds/inh2o.ogg" ; [pox]
 ;m_warriors = ""
 
-;w_generic = ""
+w_generic = "stdsounds/fanfarehappy.ogg" ; [trex0n]
 ;w_apollo_program = ""
 ;w_asmiths_trading_co = ""
 ;w_colossus = ""
diff --git a/data/stdsounds/Makefile.am b/data/stdsounds/Makefile.am
index 30d39a1532..48122a38a0 100644
--- a/data/stdsounds/Makefile.am
+++ b/data/stdsounds/Makefile.am
@@ -5,6 +5,7 @@ pkgdatadir = $(datadir)/$(PACKAGE)/stdsounds
 
 pkgdata_DATA =          \
 	fanfare.ogg	\
+	fanfarehappy.ogg \
 	foot3.ogg	\
 	illegal.ogg	\
 	inh2o.ogg	\
diff --git a/data/stdsounds/fanfarehappy.ogg b/data/stdsounds/fanfarehappy.ogg
new file mode 100644
index 0000000000000000000000000000000000000000..9f4931279875438d6692e978242c04cae0f8195d
GIT binary patch
diff --git a/meson.build b/meson.build
index ed7ec460ec..b26ddbd4ea 100644
--- a/meson.build
+++ b/meson.build
@@ -3187,6 +3187,7 @@ install_data('data/stdmusic/CullamBruce-Lockhart--Dawning_Fanfare.ogg',
              install_dir : join_paths(get_option('datadir'), 'freeciv/stdmusic'))
 
 install_data('data/stdsounds/fanfare.ogg',
+             'data/stdsounds/fanfarehappy.ogg',
              'data/stdsounds/foot3.ogg',
              'data/stdsounds/illegal.ogg',
              'data/stdsounds/inh2o.ogg',
-- 
2.43.0