From 68d67fd085e4002dc30ef7538f522c3fdf64960f Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Wed, 22 May 2024 22:09:29 +0300
Subject: [PATCH 80/80] Correct "preceed..." to "preced..."

See RM #667

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 client/gui-gtk-3.22/chatline.c |  2 +-
 client/gui-gtk-3.22/editprop.c |  2 +-
 client/gui-gtk-4.0/chatline.c  |  2 +-
 client/gui-gtk-4.0/editprop.c  |  2 +-
 client/gui-gtk-5.0/chatline.c  |  2 +-
 client/gui-gtk-5.0/editprop.c  |  2 +-
 server/ruleset/ruleload.c      |  4 ++--
 server/settings.c              | 12 ++++++------
 translations/core/check_po.pl  |  2 +-
 utility/inputfile.c            |  4 ++--
 10 files changed, 17 insertions(+), 17 deletions(-)

diff --git a/client/gui-gtk-3.22/chatline.c b/client/gui-gtk-3.22/chatline.c
index d2df53ff86..94c34828d8 100644
--- a/client/gui-gtk-3.22/chatline.c
+++ b/client/gui-gtk-3.22/chatline.c
@@ -115,7 +115,7 @@ static bool is_plain_public_message(const char *s)
   }
 
   /* Now we just need to check that it is not a private
-   * message. If we encounter a space then the preceeding
+   * message. If we encounter a space then the preceding
    * text could not have been a user/player name (the
    * quote check above eliminated names with spaces) so
    * it must be a public message. Otherwise if we encounter
diff --git a/client/gui-gtk-3.22/editprop.c b/client/gui-gtk-3.22/editprop.c
index 5f555bebd5..b7cb7c6b64 100644
--- a/client/gui-gtk-3.22/editprop.c
+++ b/client/gui-gtk-3.22/editprop.c
@@ -6380,7 +6380,7 @@ void property_editor_reload(struct property_editor *pe,
   should be freed by property_filter_free when no longed needed.
 
   The filter string is '|' ("or") separated list of '&' ("and") separated
-  lists of patterns. A pattern may be preceeded by '!' to have its result
+  lists of patterns. A pattern may be preceded by '!' to have its result
   negated.
 
   NB: If you change the behaviour of this function, be sure to update
diff --git a/client/gui-gtk-4.0/chatline.c b/client/gui-gtk-4.0/chatline.c
index 46ac847a78..250ce68ae9 100644
--- a/client/gui-gtk-4.0/chatline.c
+++ b/client/gui-gtk-4.0/chatline.c
@@ -138,7 +138,7 @@ static bool is_plain_public_message(const char *s)
   }
 
   /* Now we just need to check that it is not a private
-   * message. If we encounter a space then the preceeding
+   * message. If we encounter a space then the preceding
    * text could not have been a user/player name (the
    * quote check above eliminated names with spaces) so
    * it must be a public message. Otherwise if we encounter
diff --git a/client/gui-gtk-4.0/editprop.c b/client/gui-gtk-4.0/editprop.c
index ea3c5d68bb..78d6c960f9 100644
--- a/client/gui-gtk-4.0/editprop.c
+++ b/client/gui-gtk-4.0/editprop.c
@@ -6406,7 +6406,7 @@ void property_editor_reload(struct property_editor *pe,
   should be freed by property_filter_free when no longed needed.
 
   The filter string is '|' ("or") separated list of '&' ("and") separated
-  lists of patterns. A pattern may be preceeded by '!' to have its result
+  lists of patterns. A pattern may be preceded by '!' to have its result
   negated.
 
   NB: If you change the behaviour of this function, be sure to update
diff --git a/client/gui-gtk-5.0/chatline.c b/client/gui-gtk-5.0/chatline.c
index e0ec52cf30..5ebdc0430d 100644
--- a/client/gui-gtk-5.0/chatline.c
+++ b/client/gui-gtk-5.0/chatline.c
@@ -138,7 +138,7 @@ static bool is_plain_public_message(const char *s)
   }
 
   /* Now we just need to check that it is not a private
-   * message. If we encounter a space then the preceeding
+   * message. If we encounter a space then the preceding
    * text could not have been a user/player name (the
    * quote check above eliminated names with spaces) so
    * it must be a public message. Otherwise if we encounter
diff --git a/client/gui-gtk-5.0/editprop.c b/client/gui-gtk-5.0/editprop.c
index 3c0a66bcc0..9afecbfb66 100644
--- a/client/gui-gtk-5.0/editprop.c
+++ b/client/gui-gtk-5.0/editprop.c
@@ -6406,7 +6406,7 @@ void property_editor_reload(struct property_editor *pe,
   should be freed by property_filter_free when no longed needed.
 
   The filter string is '|' ("or") separated list of '&' ("and") separated
-  lists of patterns. A pattern may be preceeded by '!' to have its result
+  lists of patterns. A pattern may be preceded by '!' to have its result
   negated.
 
   NB: If you change the behaviour of this function, be sure to update
diff --git a/server/ruleset/ruleload.c b/server/ruleset/ruleload.c
index 8cae8abfd9..7ca83666b6 100644
--- a/server/ruleset/ruleload.c
+++ b/server/ruleset/ruleload.c
@@ -4721,7 +4721,7 @@ static bool is_on_allowed_list(const char *name, const char **list, size_t len)
 }
 
 /**********************************************************************//**
-  This function loads a city name list from a section file.  The file and
+  This function loads a city name list from a section file. The file and
   two section names (which will be concatenated) are passed in.
 **************************************************************************/
 static bool load_city_name_list(struct section_file *file,
@@ -4738,7 +4738,7 @@ static bool load_city_name_list(struct section_file *file,
 
   /* Each string will be of the form "<cityname> (<label>, <label>, ...)".
    * The cityname is just the name for this city, while each "label" matches
-   * a terrain type for the city (or "river"), with a preceeding ! to negate
+   * a terrain type for the city (or "river"), with a preceding ! to negate
    * it. The parentheses are optional (but necessary to have the settings,
    * of course). Our job is now to parse it. */
   for (j = 0; j < dim; j++) {
diff --git a/server/settings.c b/server/settings.c
index 60ff1ad62d..77999c1208 100644
--- a/server/settings.c
+++ b/server/settings.c
@@ -993,8 +993,8 @@ static bool autosaves_callback(unsigned value, struct connection *caller,
 }
 
 /************************************************************************//**
-  Verify that a given allowtake string is valid.  See
-  game.allow_take.
+  Verify that a given allowtake string is valid.
+  See game.allow_take.
 ****************************************************************************/
 static bool allowtake_callback(const char *value,
                                struct connection *caller,
@@ -1004,12 +1004,12 @@ static bool allowtake_callback(const char *value,
   int len = strlen(value), i;
   bool havecharacter_state = FALSE;
 
-  /* We check each character individually to see if it's valid.  This
+  /* We check each character individually to see if it's valid. This
    * does not check for duplicate entries.
    *
-   * We also track the state of the machine.  havecharacter_state is
-   * true if the preceeding character was a primary label, e.g.
-   * NHhAadb.  It is false if the preceeding character was a modifier
+   * We also track the state of the machine. havecharacter_state is
+   * true if the preceding character was a primary label, e.g.
+   * NHhAadb. It is false if the preceding character was a modifier
    * or if this is the first character. */
 
   for (i = 0; i < len; i++) {
diff --git a/translations/core/check_po.pl b/translations/core/check_po.pl
index f66ee090a8..890223235f 100644
--- a/translations/core/check_po.pl
+++ b/translations/core/check_po.pl
@@ -78,7 +78,7 @@ sub print_one {
     print "  $name \"", join("\"\n  \"", @_), "\"\n";
 }
 
-# Print a problem (args like print()), preceeded by entry unless
+# Print a problem (args like print()), preceded by entry unless
 # we have already printed that: label, and msgid and msgstr.
 #
 sub print_problem {
diff --git a/utility/inputfile.c b/utility/inputfile.c
index f560fedb61..a911c9bbba 100644
--- a/utility/inputfile.c
+++ b/utility/inputfile.c
@@ -30,7 +30,7 @@
   The tokens recognised are as follows:
   (Single quotes are delimiters used here, but are not part of the
   actual tokens/strings.)
-  Most tokens can be preceeded by optional whitespace; exceptions
+  Most tokens can be preceded by optional whitespace; exceptions
   are section_name and entry_name.
 
   section_name:  '[foo]'
@@ -760,7 +760,7 @@ static const char *get_token_eol(struct inputfile *inf)
 
 /*******************************************************************//**
   Get a flag token of a single character, with optional
-  preceeding whitespace.
+  preceding whitespace.
 ***********************************************************************/
 static const char *get_token_white_char(struct inputfile *inf,
                                         char target)
-- 
2.43.0